(($) ->
	$ ->
		# 使用变量
		stageWidth = $(window).width()
		stageHeight = $(window).height()
		layers = $(".ls-layer")
		num = layers.length
		cur = prev = next = 0
		fullscreenToggle = false

		# 初始化容器宽高
		$(".ls-container").css(
			width: stageWidth
			height: stageHeight
		)

		# 初始化位置
		initPos = () ->
			for i in [0..num-1]
				if i is cur
					layers.eq(i).css 'left', 0 
					layers.eq(i).attr 'data-x', 0
				else if i is prev
					layers.eq(i).css 'left', -stageWidth 
					layers.eq(i).attr 'data-x', -stageWidth 
				else 
					layers.eq(i).css 'left', stageWidth 
					layers.eq(i).attr 'data-x', stageWidth
			return

		# 初始化浮层
		initOverlay = ->
			$(".ls-overlay").css(
				height: stageHeight + 50
				width: stageWidth
				top: stageHeight - 150
				# opacity: 0
			)

			# componentsTween(1, 0)
			return

		# 拨动浮标
		updateCur = (dir) ->
			if dir is 1 then cur = (cur + 1) % num
			if dir is -1 then cur = (num + cur - 1) % num
			# if dir is 0 then cur = 0
			prev = (num + cur - 1) % num
			next = (num + cur + 1) % num
			return

		# 深度排序
		sortDepth = (dir) ->
			for i in [0..num-1]
				if i is cur
					layers.eq(i).css 'zIndex', 1
				else if i is prev
					layers.eq(i).css 'zIndex', 2 
				else if i is next
					layers.eq(i).css 'zIndex', 2
				else 
					layers.eq(i).css 'zIndex', -1
			return

		# 向前翻动
		forwardHandler = ->
			tweenLine(1)

		# 向后翻动
		backHandler = ->
			tweenLine(-1)
			return

		tweenLine = (dir) ->
			window.isActive = true
			ftl = new TimelineLite()
			if dir is 1 
				_target = next 
			else if dir is -1 
				_target = prev
			else
				_target = cur 

			# add to timeline
			ftl.add( TweenLite.to(layers.eq(_target), .5, {
				left: 0
				ease: Quint.easeOut
				# execute when timeline end
				onCompleteParams: [dir]
				onComplete: ->
					updateCur(dir)
					initPos()
					sortDepth()
					layers.eq(cur).siblings().find(".ls-overlay").css(
						opacity: 0
					)
					if cur is num-1 
						$(".btn-func").hide()
					else if cur is num-2
						$(".btn-func").show()
					return
			}), 0 );


			componentsTween(dir, _target)
			return

		componentsTween = (dir, _target) ->
			ftl = new TimelineLite()

			$overlay = layers.eq(_target).find(".ls-overlay")
			$no = layers.eq(_target).find(".ls-s-1")
			$tit = layers.eq(_target).find(".ls-s-2")
			$cont = layers.eq(_target).find(".ls-s-3")

			ftl.add( TweenLite.to($overlay, 1, {
				opacity: 1
				ease: Quad.easeOut
			}), .3 );

			# init components' left position
			$overlay.css(
				left: 0
			)
			$no.css(
				left: 15
			)
			$tit.css(
				left: 55
			)
			$cont.css(
				left: 12
			)
			ftl.add( TweenLite.from($overlay, .3, {
				left: dir * stageWidth
				ease: Power1.easeOut
			}), .3 );
			ftl.add( TweenLite.from($no, .3, {
				left: dir * stageWidth
				ease: Expo.easeOut
			}), .3 );
			ftl.add( TweenLite.from($tit, .4, {
				left: dir * stageWidth
				ease: Expo.easeOut
			}), .5 );
			ftl.add( TweenLite.from($cont, .6, {
				left: dir * stageWidth
				ease: Expo.easeOut

				# execute when timeline end
				onComplete: ->
					window.isActive = false
					return
			}), .9 );

			# timeline play
			ftl.play();
			return

		# 左扫
		$(".ls-container").swipeLeft (event) ->
			if window.isActive
				e.stopPropagation()
				return
			forwardHandler()
			return

		# 右扫
		$(".ls-container").swipeRight (event) ->
			if window.isActive
				e.stopPropagation()
				return
			backHandler()
			return

		# 上扫
		$(".ls-overlay").tap (event) ->
			toggle = $("body").attr("data-full") is "true"
			if not toggle
				TweenLite.to(layers.find(".ls-overlay"), .5, {
					top: 0
					ease: Expo.easeOut
				})
				TweenLite.to(layers.find(".ls-s-3"), .5, {
					height: '100%'
				})
				layers.find(".arrow")
				.addClass("fa-arrow-down")
				.removeClass("fa-arrow-up")
				$(".btn-func").fadeOut()
			else 
				TweenLite.to(layers.find(".ls-overlay"), .5, {
					top: stageHeight - 150
					ease: Expo.easeOut
				})
				TweenLite.to(layers.eq(cur).find(".ls-s-3"), .3, {
					height: 80
				})
				layers.find(".arrow")
				.addClass("fa-arrow-up")
				.removeClass("fa-arrow-down")
				$(".btn-func").fadeIn()
			$("body").attr("data-full", !toggle)
			return

		# 点击
		$(".ls-bg").tap ->
			toggle = $("body").attr("data-toggle") is "true"
			if not toggle
				# TweenLite.to(layers.find(".ls-overlay"), .5, {
				# 	top: stageHeight
				# 	ease: Expo.easeOut
				# })
			else 
				TweenLite.to(layers.find(".ls-overlay"), .5, {
					top: stageHeight - 150
					ease: Expo.easeOut
				})
			TweenLite.to(layers.find(".ls-s-3"), .3, {
				height: 80
			})
			$("body").attr("data-toggle", !toggle)
			return


		# 触屏事件
		$("body").on 'touchstart ', (e) ->
			if window.isActive
				# e.stopPropagation()
				return
			touch.x1 = e.changedTouches[0].pageX
			touch.y1 = e.changedTouches[0].pageY

			parent = $(e.target).parent()[0];
			if parent.tagName == "A"
				window.location.href = parent.href

			# 防止 touchmove 只触发一次
			if e.target.tagName != "A" 
				e.preventDefault()
			return
		# $(".ls-layer.app a").on 'tap', (e) ->
		# 	alert(e.currentTarget.href)
		# 	window.location.href = e.currentTarget.href
		# 	return

		$("body").on 'touchmove ', (e) ->
			if window.isActive 
				e.stopPropagation()
				return
			touch.x2 = e.changedTouches[0].pageX
			touch.y2 = e.changedTouches[0].pageY
			deltaX = touch.x1 - touch.x2
			deltaY = touch.y1 - touch.y2

			if cur is num-1 and deltaX > 0 and fullscreenToggle isnt true
				e.stopPropagation()
				return
			if cur is 0 and deltaX < 0 and fullscreenToggle isnt true
				e.stopPropagation()
				return

			$cur = layers.eq(cur)
			$prev = layers.eq(prev)
			$next = layers.eq(next)

			$cur.css(
				left: -deltaX
			)
			$prev.css(
				left: $prev.attr("data-x") - deltaX
			)
			$next.css(
				left: $next.attr("data-x") - deltaX
			)
			return

		$("body").on 'touchend ', (e) ->
			touch.x2 = e.changedTouches[0].pageX
			touch.y2 = e.changedTouches[0].pageY
			deltaX = touch.x1 - touch.x2
			deltaY = touch.y1 - touch.y2

			$cur = layers.eq(cur)
			$prev = layers.eq(prev)
			$next = layers.eq(next)

			if Math.abs(deltaX) < 60
				TweenLite.to($cur, .1, {
					left: 0
				})
				TweenLite.to($prev, .1, {
					left: $prev.attr("data-x")
				})
				TweenLite.to($next, .1, {
					left: $next.attr("data-x")
				})

			# window.isActive = true
			return

		# 查看大图
		fullscreen = ->
			bigimg = layers.eq(cur).find(".ls-bg").attr('data-zoom-image')
			if bigimg is '' then return

			$(".btn-func")
			.html('<i class="fa fa-compress"></i> 退出原图')
			.unbind('tap', fullscreen)
			.bind('tap', exitFullscreen)
			$("#zoomer img").attr("src", bigimg)

			fullscreenToggle = true;
			if window.zoomerScroll?
		    	window.zoomerScroll.destroy()

			$("#zoomer").fadeIn 500, () ->
				# 此处有点问题，待详查
				window.zoomerScroll = new IScroll( "#zoomer", {
					scrollbars: true, 
					interactiveScrollbars: true 
					# eventPassthrough: true, 
					scrollX: true, 
					scrollY: true, 
					preventDefault: true
				})
			return

	    # 退出大图
		exitFullscreen = ->
			$(".btn-func")
			.html('<i class="fa fa-expand"></i> 查看原图')
			.unbind('tap', exitFullscreen)
			.bind('tap', fullscreen)

			$("#zoomer").fadeOut 500
			fullscreenToggle = false;
			return 

		# 首次绑定
		$(".btn-func").bind('tap', fullscreen)


		##############
		# 初始化入口 #
		##############
		touch = {}
		touchToggle = false
		window.isActive = false

		updateCur(0)
		sortDepth()
		initPos()
		initOverlay()

		return
	return
)(Zepto)